#ifndef TreeGenHH
#define TreeGenHH

template<unsigned Wid, unsigned Hei, unsigned BranchWid>
void CreateTree(const unsigned char ball[Hei][Wid],
                const unsigned char branch[BranchWid],
                unsigned char* dest,
                unsigned x, unsigned y,
                unsigned BranchHei)
{
    for(unsigned i = 0; i < Wid; ++i)
        for(unsigned j = 0; j < Hei; ++j)
            dest[x+i + 16*(y+j)] = ball[j][i];

    const unsigned bx = x + Wid/2 - BranchWid/2;
    const unsigned by = y + Hei;

    for(unsigned iy=0; iy<BranchHei; ++iy)
        for(unsigned ix = 0; ix < BranchWid; ++ix)
            dest[bx+ix + 16*(by+iy)] = branch[ix];
}

#endif
