#include "pairs.hh"

Level Cutman =
{
	0, // level number
	"Cutman",

	// screens:
	{
		{
		"################"   "                "
		"................"   "                "
		"................"   "       c        "
		"................"   "                "
		"................"   "    m           "
		"................"   "  f     j   f   "
		"#####|####|#..##"   "                "
		"     |  ..|....."   "                "
		"     |  ..|....."   "                "
		"     |  ..|....."   "                "
		"     |  GGGG...."   "                "
		"     |  GGGG...."   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 0 // monster graphics index
		,LevelBegin| Right},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"#####|####|#..##"   "                "
		"     |  ..|....."   "                "
		"     |  ..|....."   "                "
		"     |  ..|....."   "          u     "
		"     |  ........"   "                "
		"     |  ........"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 0 // monster graphics index
		,Right},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "   y            "
		"................"   "        y       "
		"........GG......"   "                "
		".##.....GG......"   "                "
		"......####......"   "       y        "
		"......####..##.."   "                "
		"....######..##.."   "                "
		"....######..####"   "                "
		"##########..####"   "                "
		"##########..####"   "                "
		"##########..####"   "                "
		"##########..####"   "                "
		, 0 // monster graphics index
		,Right},
		{
		"........    #|##"   "                "
		"........    #|##"   "                "
		"........     |##"   "                "
		"........     |##"   "                "
		"....#|#  #######"   "   <            "
		"....#|#  #######"   "                "
		"....#|      ####"   "                "
		"....#|      ####"   "           <    "
		"....#|      ####"   "                "
		"....#|###   ####"   "                "
		"....       #####"   "                "
		"....       #####"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 0 // monster graphics index
		,Up},
		{
		".............|##"   "                "
		".............|##"   "                "
		".............|##"   "                "
		"..........######"   "         {      "
		"..........######"   "                "
		"........########"   "       <        "
		"........########"   "                "
		"......##########"   "                "
		"..|#..##########"   "                "
		"..|#....      ##"   "             <  "
		"..|.....      ##"   "                "
		"..|.....      ##"   "                "
		"..|.....      ##"   "                "
		"##########  #|##"   "                "
		"##########  #|##"   "                "
		"##########  #|##"   "                "
		, 0 // monster graphics index
		,Up},
		{
		"..........   |##"   "                "
		"..........   |##"   "                "
		"..........   |##"   "                "
		"..........  ####"   "           {    "
		"..........  ####"   "                "
		"..|#......######"   "                "
		"..|#......######"   "                "
		"..|.....#|######"   "       <        "
		"..|.....#|######"   "                "
		"..|......|    ##"   "                "
		"..|......|    ##"   "                "
		"..##.....|    ##"   "    >           "
		"..##.....|    ##"   "                "
		"..###...#####|##"   "                "
		"..###...#####|##"   "                "
		"..###...#####|##"   "                "
		, 0 // monster graphics index
		,Up},
		{
		"...|  ##########"   "                "
		"...|   #########"   "                "
		"...|      ######"   "         <      "
		"...|       #####"   "                "
		"...|        ####"   "                "
		"...#####    ####"   "           {    "
		"....        ####"   "                "
		"....        ####"   "                "
		"...#|###########"   "                "
		"....|       ####"   "                "
		"....|         ##"   "                "
		"....|         ##"   "                "
		"....|         ##"   "                "
		"...####  ####|##"   "       >        "
		"...####  ####|##"   "                "
		"...####  ####|##"   "                "
		, 0 // monster graphics index
		,Up},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"......CCCCCC...."   "                "
		"......CCCCCC...."   "                "
		"......CCCCCC...."   "                "
		"......CCCCCC...."   "         r      "
		"......CCCCCC####"   "                "
		"...|############"   "                "
		"...|############"   "                "
		"...|############"   "                "
		, 0 // monster graphics index
		,Right},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"........GG......"   "                "
		".##.....GG......"   "       j        "
		"......####......"   "                "
		"......####..##.."   "     j          "
		"....######..##.."   "                "
		"....######..####"   "   j            "
		"##########..####"   "                "
		"##########..####"   "                "
		"##########..####"   "                "
		"##########..####"   "                "
		, 0 // monster graphics index
		,Right},
		{
		"........    #|##"   "                "
		"........    #|##"   "                "
		"........     |##"   "                "
		"........     |##"   "                "
		"....#|#  #######"   "                "
		"....#|#  #######"   "                "
		"....#|      ####"   "      c         "
		"....#|      ####"   "                "
		"....#|      ####"   "           h    "
		"....#|###   ####"   "                "
		"....       #####"   "    c           "
		"....       #####"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 0 // monster graphics index
		,Up},
		{
		"##........   |##"   "                "
		"##........   |##"   "                "
		"##........   |##"   "                "
		"##........   |##"   "                "
		"####......  ####"   "    h           "
		"##........    ##"   "                "
		"##......##    ##"   "       h        "
		"####|#..    ####"   "                "
		"##..|...      ##"   "     c       h  "
		"##..|...      ##"   "                "
		"##..|.GG      ##"   "                "
		"##..|.GG      ##"   "                "
		"#############|##"   "                "
		"#############|##"   "                "
		"#############|##"   "                "
		"#############|##"   "                "
		, 0 // monster graphics index
		,Up| RestartPointA},
		{
		"##|.....      ##"   "                "
		"##|.....      ##"   "                "
		"##|.....      ##"   "                "
		"##|.....      ##"   "                "
		"##|.....      ##"   "             h  "
		"##|.....      ##"   "                "
		"##|.....    ####"   "           h    "
		"##|.....    ####"   "                "
		"##GG....  ######"   "                "
		"##GG....  ######"   "                "
		"######..########"   "       h        "
		"######..      ##"   "        c       "
		"######..      ##"   "                "
		"#############|##"   "                "
		"#############|##"   "                "
		"#############|##"   "                "
		, 0 // monster graphics index
		,Up},
		{
		"###|############"   "                "
		"###|############"   "                "
		"##.|....      ##"   "            c   "
		"##.|....      ##"   "                "
		"##......      ##"   "  h             "
		"##......      ##"   "                "
		"####|...    ####"   "                "
		"##..|...    ####"   "   c            "
		"##..|.GG    ####"   "        h       "
		"##..|.GG    ####"   "                "
		"##..############"   "   h            "
		"##..############"   "                "
		"##..############"   "                "
		"##|#############"   "                "
		"##|#############"   "                "
		"##|#############"   "                "
		, 0 // monster graphics index
		,Up},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"##.............."   "                "
		"##.............."   "                "
		"##.............."   "                "
		"##.............."   "                "
		"##....CCCCCC...."   "                "
		"##....CCCCCC...."   "                "
		"##....CCCCCC...."   "                "
		"##....CCCCCC...."   "         r      "
		"##....CCCCCC..##"   "                "
		"###|############"   "                "
		"###|############"   "                "
		"###|############"   "                "
		, 0 // monster graphics index
		,Right},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"......##########"   "                "
		"......##########"   "                "
		"..##############"   "                "
		"..##############"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 0 // monster graphics index
		,Right},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "      y         "
		"................"   "          y     "
		"................"   "                "
		"................"   "                "
		"############...."   "         y      "
		"############...."   "                "
		"##.............."   "                "
		"##.............."   "  E             "
		"############|#.."   "                "
		"############|#.."   "                "
		"############|#.."   "                "
		"############|#.."   "                "
		, 0 // monster graphics index
		,Down},
		{
		"######......|..."   "                "
		"#####.......|..."   "                "
		"#####.......|..."   "                "
		"######|#######.."   "                "
		"######|#######.."   "                "
		"#### ..........."   "                "
		"#### ..........."   "                "
		"##   ..........."   "                "
		"##   ..........."   "               u"
		"##   .##..##...."   "                "
		"##   ..........."   "                "
		"##   ..........."   "                "
		"##   ..........."   "                "
		"######|#........"   "                "
		"######|#........"   "                "
		"######|#........"   "                "
		, 1 // monster graphics index
		,Down},
		{
		"######|#........"   "                "
		"######|#........"   "                "
		"######  ........"   "                "
		"######  .....^^."   "                "
		"########.....##."   "                "
		"########........"   "                "
		"####  .........."   "                "
		"####  .........."   "                "
		"##    .........."   "               u"
		"##    .##....##."   "                "
		"##    .........."   "                "
		"##    .........."   "                "
		"##    .........."   "                "
		"##|#####^^^^^^^^"   "                "
		"##|#############"   "                "
		"##|#############"   "                "
		, 1 // monster graphics index
		,Down},
		{
		"##|............."   "                "
		"##|............."   "                "
		"##|............."   "                "
		"##|............."   "                "
		"##.............."   "                "
		"##.............."   "                "
		"##.............."   "                "
		"##.............."   "                "
		"##GGGG.........."   "                "
		"##GGGG.........."   "                "
		"####GGGG........"   "              t "
		"####GGGG........"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 2 // monster graphics index
		,Right},
		{
		".............###"   "                "
		".............###"   "                "
		".............###"   "                "
		".............###"   "                "
		".............###"   "                "
		".............###"   "                "
		"..............DD"   "              SS"
		"..............DD"   "              SS"
		"..............DD"   "              SS"
		"..............DD"   "              SS"
		"..........######"   "                "
		"..........######"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 2 // monster graphics index
		,Shutter},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"################"   "                "
		"################"   "                "
		"                "   "                "
		"                "   "                "
		"                "   "                "
		"                "   "                "
		"################"   "             v  "
		"################"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		, 3 // monster graphics index
		,RestartPointB| Right},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"################"   "                "
		"################"   "                "
		"                "   "            .   "
		"                "   "                "
		"                "   "                "
		"                "   "                "
		"################"   "                "
		"################"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		, 3 // monster graphics index
		,Right},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"################"   "                "
		"################"   "                "
		"               D"   "               S"
		"               D"   "               S"
		"               D"   "               S"
		"               D"   "               S"
		"################"   "     v          "
		"################"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		, 3 // monster graphics index
		,Shutter},
		{
		"################"   "                "
		"################"   "                "
		"#              #"   "                "
		"#              #"   "                "
		"#              #"   "                "
		"#              #"   "                "
		"               #"   "                "
		"               #"   "                "
		"               #"   "                "
		"               #"   "                "
		"##GGGG         #"   "                "
		"##GGGG         #"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 4 // monster graphics index
		,End},
	},

	// palette
	{
		15, 48, 43,  6, 
		15, 48, 43, 44, 
		15, 32, 16,  0, 
		15, 32, 16, 44, 

		15, 44, 17, 15, 
		15, 32, 56, 15, 
		15, 48, 17, 15, 
		15, 48, 21, 15, 

		15, 48, 43,  6, 
		15, 48, 43, 44, 
		15, 48, 32, 16, 
		15, 32, 16, 44, 
	},

	// after doors palette
	{
		15, 32, 33, 17, 
		15, 32, 60, 44, 
		15, 32, 33, 44, 
		15, 32,  9, 28, 

	},

	// actives
	{
	},

	// enemies
	{
	},
	
	// level gfx (id, count) (max 16); id is block*4+bank
	{
		{ 0x40, 8 },
		//
		{ 0x6E, 1 },
		{ 0x7E, 1 },
		{ 0xBE, 1 }, 
		{ 0x6A, 1 },
		{ 0x72, 1 },
		//
		{ 0xE2, 1 },
		{ 0xD8, 1 },
		{ 0x5E, 1 },
		{ 0xC0, 8 },
		{ 0x41, 8 }, 
	},

	// monster gfx tables (max 11) (5 tiles, 2*3bytepalette)
	{
		{ { 0x6E, 0x7E, 0xBE, 0x62, 0x72, }, { 48,17,15, 48,21,15,} },
		{ { 0x6E, 0x7E, 0xBE, 0x62, 0x72, }, { 48,38,15, 48,38,15,} },
		{ { 0x96, 0xC2, 0xC6, 0x7A, 0x7E, }, { 48,21,15, 48,38,15,} },
		{ { 0x96, 0x9A, 0x9E, 0x7A, 0x7E, }, { 48,17,15, 48,38,15,} },
		{ { 0x60, 0x64, 0x68, 0x6C, 0x46, }, { 48,21,15, 48,38,15,} },
	},

	0x00, // Arrival input

	CutmanAscii, CutmanChar
};
